=== debian/changelog ===
ausweisapp2 (1.22.0-1) unstable; urgency=medium

  * New upstream release (Closes: #960568)
  * Add libqt5qmlworkerscript5 to Build-Depends in debian/control
  * Fix bogus and missing QML packages in Depends of binary
    package in debian/control (Closes: #970085)
  * Add patch to fix installation path of manpage

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Wed, 02 Dec 2020 21:18:30 +0100
