=== debian/changelog ===
ausweisapp2 (1.22.2-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.5.1 in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sun, 08 Aug 2021 22:03:58 +0200

ausweisapp2 (1.22.1-1) unstable; urgency=medium

  * New upstream release
  * Drop 0001-Fix-installation-path-of-manpage.patch, fixed upstream

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Fri, 06 Aug 2021 08:22:18 +0200
