=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 	       qtquickcontrols2-5-dev,
 	       qttools5-dev,
 	       cmake
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://www.ausweisapp.bund.de
 Vcs-Browser: https://salsa.debian.org/debian/ausweisapp2
 Vcs-Git: https://salsa.debian.org/debian/ausweisapp2.git
