=== debian/changelog ===
ausweisapp2 (1.22.3-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 27 Jan 2022 13:42:33 +0100

ausweisapp2 (1.22.3-1) unstable; urgency=medium

  * New upstream release
  * Update Standards-Version to 4.6.0 in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Thu, 20 Jan 2022 10:14:21 +0100
